!//////////////////////////////////////////////////////////////////////
!          ______   ______   _____    ______
!         / ____/  / ____/  / ___/   / ____/
!        / __/    / / __    \__ \   /___ \
!       / /___   / /_/ /   ___/ /  ____/ /
!      /_____/   \____/   /____/  /_____/
!
      program det3
!//////////////////////////////////////////////////////////////////////
      implicit none
!     ~~~~~~~ EGS/PEGS/COMMON parameters ~~~~~~
      include 'include/egs5_h.f'         ! MAIN header, MXMED, MXREG, etc
      include 'include/egs5_bounds.f'    ! ECUT,PCUT
!     include 'include/egs5_edge.f'      ! IEDGFL, IAUGER, etc
      include 'include/egs5_media.f'     ! MEDIA,  USEGDS, etc
      include 'include/egs5_misc.f'      ! RHOR, MED, NREG, IRAYLR, IPROFR, etc
      include 'include/egs5_stack.f'     ! E,X,Y,Z,U,...
      include 'include/egs5_useful.f'    ! RM, MEDIUM, etc
      include 'include/egs5_usersc.f'    ! ESTEPR, EMAXE, etc
!     include 'include/egs5_userxt.f'    ! IPHTER
      include 'include/randomm.f'        ! SEEDS, RLUXSET, etc
      include 'auxcommons/instuf.f'      ! NCASES, EKEIN, XIN, IQIN, etc
      include 'auxcommons/lines.f'       ! for PRINTING (NLINES, NCOUNT, etc)
      include 'auxcommons/nfac.f'        ! DPLAY of xmin, xmax, ymin, ymax..
      include 'auxcommons/watch.f'       ! flag of IWATCH
      include 'auxcommons/geom_common.f' ! GEOM-common file for CG
!     ~~~~~~~ EGS/LOCAL parameters ~~~~~~
      integer maxpict,i,idin,ifti,ifto,nlist,j,k,n,m
      real*8 totke,rnnow,etot,availke,wtin,ae,ap,ue,up
      character*24 medarr(MXMED)
      integer IRAYL,IAPRIM,IBOUND,INCOH,ICPROF,IMPACT,IGSDST
!     integer ISSB,FPSTFL,FUDGEMS,NLEGO,IUNRST,EFRACH,EFRACL
      integer IPHTE,IEDGF,IAUGE,LPOLA
      common/cmn1/maxpict,escore,de
      real*8 escore(0:3)
!     ~~~~~~~ INITIALIZATION ~~~~~~
      npreci=3                  ! PICT data mode for CGView in free format
!     ~~~~~~~ FILEs ~~~~~~
      ifto = 39                 ! FILE number of PICT
      ifti = 4                  ! FILE number of CG-input
      open(99,FILE='egs5job.out',STATUS='unknown')
      open(4,FILE='egs5job.inp')
      open(25,FILE='pgs5job.pegs5inp')
      open(ifto,FILE='egs5job.pic',STATUS='unknown')
      call counters_out(0)  ! set zero for all counters
      
!//////////////////////////////////////////////////////////////////////
!     INPUTs of the calculation
!//////////////////////////////////////////////////////////////////////
      
!     ~~~~~~~ PARAMETERs INPUT ~~~~~~~
      ncases = 10000      
      maxpict= 50
      nmed = 1                  ! NUMBER of MEDIUM
      luxlev = 1                ! LUXURY LEVEL of Random number generator
      inseed = 1                ! INITIAL SEED

      do m=1,nmed               ! 
         ecut(m) = 0.01d0       ! CUTOFF ENERGY of e-/e+
         pcut(m) = 0.01d0       !               of photon
      enddo

!     ~~~~~~~ SOURCE INPUT ~~~~~~~
      iqin  = 0             ! Incident particle charge - photons
      ekein = 1.0d0         ! Incident particle kinetic energy
      xin   =  0.0          ! Source position
      yin   =  0.0
      zin   = -1.0
      uin   =  0.0          ! Moving along z axis
      vin   =  0.0
      win   =  1.0
      irin  =  0            ! Starting region (0: Automatic search in CG)
      wtin  = 1.0           ! Weight = 1 since no variance reduction used

!     ~~~~~~~ MATERIALs INPUT ~~~~~~~
      medarr(1) ='NAI                      '
      
!     ~~~~~~~ PEGS COPTIONs INPUT ~~~~~~~
      IRAYL  = 1    ! Rayleigh scattering
      IAPRIM = 1    ! Emrirical correction in brems XS
      IBOUND = 1    ! Bound compton XS
      INCOH  = 0    ! S/Z rejection
      ICPROF = -3   ! Doppler broadening
      IMPACT = 0    ! Electron impact ionization
!     IGSDST = 0
!     ISSB   = 0
!     FPSTFL = 0
!     FUDGEMS= 1.0
!     NLEGO  = 1000
!     IUNRST = 0
!     EFRACH = 0.05
!     EFRACL = 0.20

!     ~~~~~~~ EGS COPTIONs INPUT ~~~~~~~
      IPHTE = 1     ! Switches for PE-angle sampling
      IEDGF = 1     ! K & L-edge fluorescence
      IAUGE = 1     ! K & L-Auger
      LPOLA = 0     ! Linearly-polarized photon scattering

!/////////////////////////////////////////////////////////////
!     PREPARE CALCULATION
!/////////////////////////////////////////////////////////////

      AE = ecut(1)+RM
      AP = pcut(1)
      UE = ekein*1.01+RM  ! just e+RM is ideal but when e >> 1, RM may disapear in PEGS input
      UP = ekein

      call nmedck(nmed,MXMED)   ! check if nmed < MXMED, otherwize stop
      call block_set            ! Initialize some general variables
      call medarr2media(medarr)

!     ~~~~~~~ call PEGS ~~~~~~~
      call pegs5

      call geomgt(ifti,99)       ! Read in CG data
      call pichead(npreci,ifto,ifti)

      rewind ifti
      call geomgt(ifti,ifto)    ! Dummy call to write geom info for ifto
      write(ifto,110)
110   FORMAT('CEND')

!     ~~~~~~~ READ nreg and med from CG INPUT ~~~~~~~      
      nreg=izonin
      read(4,*) (med(i),i=1,nreg)

!     ~~~~~~~set EGS PARAMETERs ~~~~~~~
      call egspara(IPHTE,IEDGF,IAUGE,IRAYL,LPOLA,INCOH,ICPROF,IMPACT)

!     ~~~~~~~Initialize RANDOM NUMBER ~~~~~~~
      call rluxinit

!     ~~~~~~~ irin Automatic search ~~~~~~~
      if(irin.le.0.or.irin.gt.nreg) then
        call srzone(xin,yin,zin,iqin+2,0,irin)
        call irinck(irin,nreg)
        call rstnxt(iqin+2,0,irin)
      end if
      
      emaxe = 0.D0 ! dummy value to extract min(UE,UP+RM).

      open(UNIT=KMPI,FILE='pgs5job.pegs5dat',STATUS='old')
      open(UNIT=KMPO,FILE='egs5job.dummy',STATUS='unknown')

      call hatch

      close(UNIT=KMPI)
      close(UNIT=KMPO)
      write(ifto,fmt="('MSTA')")
      write(ifto,fmt="(i4)") nreg
      write(ifto,fmt="(15i4)") (med(i),i=1,nreg)
      write(ifto,fmt="('MEND')")

      ncount = 0
      ilines = 0
      nwrite = 10
      nlines = 10
      idin = -1
      totke = 0.
      iwatch=0

      write(ifto,fmt="('0    1')")
      if(iwatch.gt.0) call swatch(-99,iwatch)

!//////////////////////////////////////////////////////////////////////
!     SHOWER MAIN-LOOP
!//////////////////////////////////////////////////////////////////////      

      DO i=1,ncases  

         etot = ekein + iabs(iqin)*RM      ! Incident total energy (MeV)
         escore(0) = escore(0) + etot      ! Score indicent energy (MeV)
         call availkef(iqin,ekein,availke) ! Calc availke velue
         totke = totke + availke           ! Keep running sum of KE

         call etotck(iqin,etot)        
         call dirck(uin,vin,win)
         
!     ~~~~~~~ EGS5 MAIN ROUTINE ~~~~~~~

         call shower (iqin,etot,xin,yin,zin,uin,vin,win,irin,wtin)

         ncount = ncount + 1    ! Count total number of actual cases
         if(iwatch.gt.0) call swatch(-1,iwatch)
      ENDDO

!//////////////////////////////////////////////////////////////////////
!     POST PROCESSING
!//////////////////////////////////////////////////////////////////////      
      write(6,*)"escore results"
      write(6,*)escore(0)
      write(6,*)escore(1)
      write(6,*)escore(2)
      write(6,*)escore(3)
!     ~~~~~~~ Close PIC-file etc ~~~~~~~      
      if(iwatch.gt.0) call swatch(-88,iwatch)
      call plotxyz(99,0,0,0.D0,0.D0,0.D0,0.D0,0,0.D0,0.D0) 
      write(ifto,fmt="('9')")          ! Set end of batch for CG View
      call totkeck(totke)
      nlist=1
      call counters_out(1)

      stop
      end

!//////////////////////////////////////////////////////////////////////
!     PROGRAM END
!//////////////////////////////////////////////////////////////////////      

      
!//////////////////////////////////////////////////////////////////////      
      subroutine ausgab(iarg)
!//////////////////////////////////////////////////////////////////////      
      implicit none

      include 'include/egs5_h.f'         ! Main EGS "header" file

      include 'include/egs5_epcont.f'    ! COMMONs required by EGS5 code
      include 'include/egs5_misc.f'
      include 'include/egs5_stack.f'
      include 'include/egs5_useful.f'
      include 'auxcommons/aux_h.f'       ! Auxiliary-code "header" file
      include 'auxcommons/etaly1.f'      ! Auxiliary-code COMMONs
      include 'auxcommons/lines.f'
      include 'auxcommons/ntaly1.f'
      include 'auxcommons/watch.f'

      integer iarg,maxpict
      common/cmn1/maxpict,escore,de
      real*8 escore(0:3)

!     Print out particle transport information (if switch is turned on)
      if (iwatch .gt. 0) call swatch(iarg,iwatch)

      if ( iarg.le.4 )then
         if(     ir(np).eq.1 )then
            escore(1) = escore(1) + edep
         elseif( ir(np).eq.2 )then
            escore(2) = escore(2) + edep
         elseif( ir(np).eq.3 )then
            escore(3) = escore(3) + edep
         endif
      endif
      
      if(iarg .ge. 5) return

!     Output particle information for plot
      if (ncount.le.maxpict) then
        call plotxyz(iarg,np,iq(np),x(np),y(np),z(np),e(np),ir(np),
     *       wt(np),time(np))
      end if

      return
      end


!//////////////////////////////////////////////////////////////////////      
      subroutine howfar
!//////////////////////////////////////////////////////////////////////      
!     Do not modify in case of CG calculation
!//////////////////////////////////////////////////////////////////////      
      implicit none
c
      include 'include/egs5_h.f'       ! Main EGS "header" file
      include 'include/egs5_epcont.f'  ! COMMONs required by EGS5 code
      include 'include/egs5_stack.f'
      include 'auxcommons/geom_common.f' ! geom-common file
c
c
      integer i,j,jjj,ir_np,nozone,jty,kno
      integer irnear,irnext,irlold,irlfg,itvlfg,ihitcg
      double precision xidd,yidd,zidd,x_np,y_np,z_np,u_np,v_np,w_np
      double precision tval,tval0,tval00,tval10,tvalmn,delhow
      double precision atvaltmp
      integer iq_np
c
      ir_np = ir(np)
      iq_np = iq(np) + 2
c
      if(ir_np.le.0) then
        write(99,*) 'Stopped in howfar with ir(np) <=0'
        stop
      end if
c
      if(ir_np.gt.izonin) then
        write(99,*) 'Stopped in howfar with ir(np) > izonin'
        stop
      end if
c
      if(ir_np.EQ.izonin) then
        idisc=1
        return
      end if
c
      tval=1.d+30
      itvalm=0
c
c     body check
      u_np=u(np)
      v_np=v(np)
      w_np=w(np)
      x_np=x(np)
      y_np=y(np)
      z_np=z(np)
c
      do i=1,nbbody(ir_np)
        nozone=ABS(nbzone(i,ir_np))
        jty=itblty(nozone)
        kno=itblno(nozone)
c     rpp check
        if(jty.eq.ityknd(1)) then
          if(kno.le.0.or.kno.gt.irppin) go to 190
          call rppcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     sph check
        elseif(jty.eq.ityknd(2)) then
          if(kno.le.0.or.kno.gt.isphin) go to 190
          call sphcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     rcc check
        elseif(jty.eq.ityknd(3)) then
          if(kno.le.0.or.kno.gt.irccin) go to 190
          call rcccg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     trc check
        elseif(jty.eq.ityknd(4)) then
          if(kno.le.0.or.kno.gt.itrcin) go to 190
          call trccg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     tor check
        elseif(jty.eq.ityknd(5)) then
          if(kno.le.0.or.kno.gt.itorin) go to 190
          call torcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     rec check
        elseif(jty.eq.ityknd(6)) then
          if(kno.le.0.or.kno.gt.irecin) go to 190
          call reccg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     ell check
        elseif(jty.eq.ityknd(7)) then
          if(kno.le.0.or.kno.gt.iellin) go to 190
          call ellcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     wed check
        elseif(jty.eq.ityknd(8)) then
          if(kno.le.0.or.kno.gt.iwedin) go to 190
          call wedcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     box check
        elseif(jty.eq.ityknd(9)) then
          if(kno.le.0.or.kno.gt.iboxin) go to 190
          call boxcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     arb check
        elseif(jty.eq.ityknd(10)) then
          if(kno.le.0.or.kno.gt.iarbin) go to 190
          call arbcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     hex check
        elseif(jty.eq.ityknd(11)) then
          if(kno.le.0.or.kno.gt.ihexin) go to 190
          call hexcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     haf check
        elseif(jty.eq.ityknd(12)) then
          if(kno.le.0.or.kno.gt.ihafin) go to 190
          call hafcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     tec check
        elseif(jty.eq.ityknd(13)) then
          if(kno.le.0.or.kno.gt.itecin) go to 190
          call teccg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c     gel check
        elseif(jty.eq.ityknd(14)) then
          if(kno.le.0.or.kno.gt.igelin) go to 190
          call gelcg1(kno,x_np,y_np,z_np,u_np,v_np,w_np)
c
c**** add new geometry in here
c
       end if
  190  continue
      end do
c
      irnear=ir_np
      if(itvalm.eq.0) then
        tval0=cgeps1
        xidd=x_np+tval0*u_np
        yidd=y_np+tval0*v_np
        zidd=z_np+tval0*w_np
  310   continue
          if(x_np.ne.xidd.or.y_np.ne.yidd.or.z_np.ne.zidd) goto 320
          tval0=tval0*10.d0
          xidd=x_np+tval0*u_np
          yidd=y_np+tval0*v_np
          zidd=z_np+tval0*w_np
          go to 310
  320   continue
c       write(*,*) 'srzone:1'
        call srzone(xidd,yidd,zidd,iq_np,ir_np,irnext)
c
        if(irnext.ne.ir_np) then
          tval=0.0d0
          irnear=irnext
        else
          tval00=0.0d0
          tval10=10.0d0*tval0
          irlold=ir_np
          irlfg=0
  330     continue
          if(irlfg.eq.1) go to 340
            tval00=tval00+tval10
            if(tval00.gt.1.0d+06) then
              write(99,9000) iq(np),ir(np),x(np),y(np),z(np),
     &                      u(np),v(np),w(np),tval00
 9000 format(' TVAL00 ERROR : iq,ir,x,y,z,u,v,w,tval=',
     &       2I3,1P7E12.5)
              stop
            end if
            xidd=x_np+tval00*u_np
            yidd=y_np+tval00*v_np
            zidd=z_np+tval00*w_np
            call srzold(xidd,yidd,zidd,irlold,irlfg)
            go to 330
  340     continue
c
          tval=tval00
          do j=1,10
            xidd=x_np+tval00*u_np
            yidd=y_np+tval00*v_np
            zidd=z_np+tval00*w_np
c           write(*,*) 'srzone:2'
            call srzone(xidd,yidd,zidd,iq_np,irlold,irnext)
            if(irnext.ne.irlold) then
              tval=tval00
              irnear=irnext
            end if
            tval00=tval00-tval0
          end do
          if(ir_np.eq.irnear) then
            write(0,*) 'ir(np),tval=',ir_np,tval
          end if
        end if
      else
        do j=1,itvalm-1
          do i=j+1,itvalm
            if(atval(i).lt.atval(j)) then
              atvaltmp=atval(i)
              atval(i)=atval(j)
              atval(j)=atvaltmp
            endif
          enddo
        enddo
        itvlfg=0
        tvalmn=tval
        do jjj=1,itvalm
          if(tvalmn.gt.atval(jjj)) then
            tvalmn=atval(jjj)
          end if
          delhow=cgeps2
          tval0=atval(jjj)+delhow
          xidd=x_np+tval0*u_np
          yidd=y_np+tval0*v_np
          zidd=z_np+tval0*w_np
  410     continue
          if(x_np.ne.xidd.or.y_np.ne.yidd.or.z_np.ne.zidd) go to 420
            delhow=delhow*10.d0
            tval0=atval(jjj)+delhow
            xidd=x_np+tval0*u_np
            yidd=y_np+tval0*v_np
            zidd=z_np+tval0*w_np
          go to 410
  420     continue
c         write(*,*) 'srzone:3'
          call srzone(xidd,yidd,zidd,iq_np,ir_np,irnext)
          if((irnext.ne.ir_np.or.atval(jjj).ge.1.).and.
     &        tval.gt.atval(jjj)) THEN
            tval=atval(jjj)
            irnear=irnext
            itvlfg=1
            goto 425
          end if
        end do
  425   continue
        if(itvlfg.eq.0) then
          tval0=cgmnst
          xidd=x_np+tval0*u_np
          yidd=y_np+tval0*v_np
          zidd=z_np+tval0*w_np
  430     continue
          if(x_np.ne.xidd.or.y_np.ne.yidd.or.z_np.ne.zidd) go to 440
            tval0=tval0*10.d0
            xidd=x_np+tval0*u_np
            yidd=y_np+tval0*v_np
            zidd=z_np+tval0*w_np
            go to 430
  440     continue
          if(tvalmn.gt.tval0) then
            tval=tvalmn
          else
            tval=tval0
          end if
        end if
      end if
      ihitcg=0
      if(tval.le.ustep) then
        ustep=tval
        ihitcg=1
      end if
      if(ihitcg.eq.1) THEN
        if(irnear.eq.0) THEN
          write(99,9200) iq(np),ir(np),x(np),y(np),z(np),
     &                  u(np),v(np),w(np),tval
 9200 format(' TVAL ERROR : iq,ir,x,y,z,u,v,w,tval=',2I3,1P7E12.5)
          idisc=1
          itverr=itverr+1
          if(itverr.ge.100) then
            stop
          end if
          return
        end if
        irnew=irnear
        if(irnew.ne.ir_np) then
          call rstnxt(iq_np,ir_np,irnew)
        endif
      end if
      return
      end
!--------------------last line of subroutine howfar---------------------

      subroutine nmedck(nmed,MXMED)
      integer nmed,MXMED
      if(nmed.gt.MXMED) then
         write(6,*)''
         write(6,*)'ERROR:nmed exceeds MXMED'
         write(6,*)''         
        stop
      end if
      end
      
      subroutine medarr2media(medarr)
      include 'include/egs5_h.f' ! MAIN header, MXMED, etc      
      include 'include/egs5_media.f'     ! MEDIA,  USEGDS, etc
      character*24 medarr(MXMED)      
      do j=1,nmed
        do i=1,24
          media(i,j)=medarr(j)(i:i)
        end do
      end do  
      end

      subroutine pichead(npreci,ifto)
      integer npreci,ifto
      if(npreci.eq.3) write(ifto,fmt="('CSTA-FREE-TIME')")
      if(npreci.eq.2) write(ifto,fmt="('CSTA-TIME')")
      end

      subroutine egspara(i1,i2,i3,i4,i5,i6,i7,i8)
      include 'include/egs5_h.f'      ! MAIN header, MXMED, MXREG, etc
      include 'include/egs5_edge.f'   ! IEDGFL, IAUGER, etc
      include 'include/egs5_userxt.f' ! IPHTER      
      include 'include/egs5_misc.f'   ! RHOR, MED, NREG, IRAYLR, IPROFR, etc
      integer i,i1,i2,i3,i4,i5,i6,i7,i8
      do i =1,nreg-1
         if(med(i).ne.0) then
            iphter(i) = i1      ! Switches for PE-angle sampling
            iedgfl(i) = i2      ! K & L-edge fluorescence
            iauger(i) = i3      ! K & L-Auger
            iraylr(i) = i4      ! Rayleigh scattering
            lpolar(i) = i5      ! Linearly-polarized photon scattering
            incohr(i) = i6      ! S/Z rejection
            iprofr(i) = i7      ! Doppler broadening
            impacr(i) = i8      ! Electron impact ionization
         endif
      enddo
      end
      
      subroutine irinck(irin,nreg)
      if(irin.le.0.or.irin.ge.nreg) then
         write(99,fmt="(' Stopped in MAIN. irin = ',i5)")irin
         stop
      end if
      end
      
      subroutine etotck(iqin,etot)
      integer iqin
      include 'include/egs5_h.f'         ! MAIN header, MXMED, etc            
      include 'include/egs5_useful.f'    ! RM, MEDIUM, etc      
      include 'include/egs5_usersc.f'    ! ESTEPR, EMAXE, etc
      real*8 etot
      if(etot+(1-iabs(iqin))*RM.gt.emaxe) then 
         write(6,fmt="(' Stopped in MAIN.',
     1' (Incident kinetic energy + RM) > min(UE,UP+RM).')")
         stop
      end if
      end

      subroutine dirck(uin,vin,win)
      real*8 uin, vin, win
      if(abs(uin*uin+vin*vin+win*win-1.0).gt.1.e-6) then
         write(6,fmt="(' Following source direction cosines are not',
     1' normalized.',3e12.5)")uin,vin,win
         stop
      end if
      end

      subroutine totkeck(totke)
      real*8 totke
      if (totke .le. 0.D0) then
         write(6,320) totke,availke,ncount
 320     FORMAT(//,' Stopped in MAIN with TotKE=',G15.5,/,
     *        ' AvailKE=',G15.5, /,' Ncount=',I10)
         stop
      end if
      end

      subroutine availkef(iqin,ekein,availke)
      include 'include/egs5_useful.f' ! RM, MEDIUM, etc
      integer iqin
      real*8 ekein,availke
      if(iqin.eq.1) then           ! Available K.E. (MeV) in system 
         availke = ekein + 2.0*RM  ! for e+
      else                         !
         availke = ekein           ! for e- and photon
      end if
      end

      





